/*
 * LVmodel.java
 *
 * Created on Utorok, 2005, janur 18, 1:08
 */

/**
 *
 * @author  X-so
 */
import java.text.*;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import javax.swing.*;

public class LVmodel extends javax.swing.JApplet  {
    private m_JVGraph m_Graph;
    private m_JKPGraph m_KPGraph;
    private double a,b,c,d;
    private m_JLV m_LV;
    private m_JPoint PHPoint;
    private double x[];
    private double y1[];
    private double y2[];
    DecimalFormat decFormat;
    
     /** Initializes the applet LVmodel */
    public double[][] CountRK() {
        double ret[][]= new double[2][3];
        double max[] = new double[3];
        double min[] = new double[3];
        double r[];
        x = new double[m_Graph.GetWidth()*10+10];
        y1 = new double[m_Graph.GetWidth()*10+10];
        y2 = new double[m_Graph.GetWidth()*10+10];
        
        m_LV.SetParams(a,b,c,d);
        m_LV.setH(0.1);
        
        double K=PHPoint.m_doubleValueX.Get();
        double P=PHPoint.m_doubleValueY.Get();
        x[0]=0;
        y1[0]=K;
        y2[0]=P;
            //nastav polia
        for(int i = 0 ; i < 3 ; i++){
            min[i]=Double.MAX_VALUE;
            max[i]=Double.MIN_VALUE;
        }
        double step=0.1;
        int counter=1;
        for(double t = 0 ; t < m_Graph.GetWidth(); t+=0.1){
           
            r=m_LV.Fn(t,y1[counter-1],y2[counter-1]);
            x[counter]=t;
            y1[counter]=r[1];
            y2[counter]=r[2];
            if(max[0] < x[counter]) max[0]=x[counter]; 
            if(min[0] > x[counter]) min[0]=x[counter];
            
            if(max[1] < y1[counter]) max[1]=y1[counter];
            if(min[1] > y1[counter]) min[1]=y1[counter];
            
            if(max[2] < y2[counter]) max[2]=y2[counter];        
            if(min[2] > y2[counter]) min[2]=y2[counter];
            counter++;
        }
        ret[0][0] = min[0];
        ret[0][1] = min[1];
        ret[0][2] = min[2];
        ret[1][0] = max[0];
        ret[1][1] = max[1];
        ret[1][2] = max[2];
        //x-sova os je cas; y-silonova je hodnota
    
        //!!!! zmeneny vystup parametra max uprav !
    return ret;
   }
    
    private void Recount() {
                //zastav thready
        m_Graph.stop();
        m_KPGraph.stop();
               //nastav novehodnoty do P0,H0
        PHPoint.Set(Double.valueOf(m_ValueK0.getText()).doubleValue(),Double.valueOf(m_ValueP0.getText()).doubleValue());
              //zistak parametre a,b,c,d
        GetSetParams();
               //nastav parametre do vektoroveho grafu
        m_Graph.SetParams(a,b,c,d);
              //nastav EQ point
        SetEQPoint();   
             //vypocitaj RK
        double ret[][]=CountRK();
             //nastav hodnoty
        m_KPGraph.SetInputValues(ret, x, y1, y2);
        ret[0][0]=ret[1][0];
        ret[1][0]=ret[1][1];
        m_Graph.SetInputValues(ret, y1, y1, y2);
        
             //spusti nove thready
        m_Graph.start();
        m_KPGraph.start();
 }
    
    /** Inicializacia vsetkeho mozneho */
      public void init() {
            //zavolaj Smetiara ;)
        System.gc();
            //nastav nejaky slusny pocet destainnych miest
        DecimalFormatSymbols decimalformatsymbols = new DecimalFormatSymbols();
        decimalformatsymbols.setDecimalSeparator('.');
        decFormat = new DecimalFormat("#0.00", decimalformatsymbols);
        
        //nainicializuj GUI
        initComponents();
        initVectorGraph();
        initKPGraph();
        m_Graph.start();
        m_KPGraph.start();
               //nainicializuj globalne premenne
        m_LV = new m_JLV();  //classa na vypocet systemu lotka-volterra
        PHPoint = new m_JPoint(); //ulozene hodnoty o bode P0,H0
        x=null;
        y1=null;
        y2=null;
        

    }
    
    /** Inicializacia grafu s krivkami K(t),P(t) */
    private void initKPGraph() {
        m_KPGraph = new m_JKPGraph();
        m_KPGraph.addMouseListener(new java.awt.event.MouseAdapter() {
              public void mouseExited(java.awt.event.MouseEvent evt) {
                m_KPGraph.MouseExited(evt);
            }
        });
    
        m_KPGraph.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                m_KPGraph.MouseMoved(evt);
            }
        });
        getContentPane().add(m_KPGraph);
        
        int maxK=Double.valueOf(m_ValueK0.getText()).intValue();
        int maxP=Double.valueOf(m_ValueP0.getText()).intValue();
        int max = 0;
        if(maxK > maxP){ 
            max = maxK;
        }
        else {
            max = maxP;
        }
        m_KPGraph.setBounds(190, 250, 400, 200);
        //x-sova os je cas; y-silonova je hodnota
        m_KPGraph.init(400,200,15,15,0,30,0,40);
        
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel3.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel3.setText("K(t),");
        getContentPane().add(jLabel3);
        jLabel3.setBounds(130, 260, 30, 90);

        jLabel4.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setText("P(t)");
        jLabel4.setForeground(new java.awt.Color(255, 0, 0));
        getContentPane().add(jLabel4);
        jLabel4.setBounds(160, 260, 20, 90);

        jLabel5.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel5.setText("t");
        getContentPane().add(jLabel5);
        jLabel5.setBounds(340, 450, 70, 30);
    }
    private void initVectorGraph() {
        m_Graph = new m_JVGraph();
        m_Graph.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                m_GraphMouseClicked(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                    m_Graph.MouseExited(evt);
            }
        });
    
        m_Graph.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                m_Graph.MouseMoved(evt);
            }
        });
        getContentPane().add(m_Graph);
        
        m_Graph.setBounds(190, 10, 400, 200);      
        m_Graph.init(400,200,20,15,0,30,0,20);

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("P");
        getContentPane().add(jLabel1);
        jLabel1.setBounds(150, 80, 20, 90);

        jLabel2.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel2.setText("K");
        getContentPane().add(jLabel2);
        jLabel2.setBounds(340, 210, 70, 30);
    }
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        m_ControlPannel = new javax.swing.JPanel();
        m_ValueA_LBL = new javax.swing.JLabel();
        m_ValueA = new javax.swing.JTextField();
        m_ValueB_LBL = new javax.swing.JLabel();
        m_ValueB = new javax.swing.JTextField();
        m_ValueC_LBL = new javax.swing.JLabel();
        m_ValueC = new javax.swing.JTextField();
        m_ValueD_LBL = new javax.swing.JLabel();
        m_ValueD = new javax.swing.JTextField();
        m_ValueP0_LBL = new javax.swing.JLabel();
        m_ValueP0 = new javax.swing.JTextField();
        m_ValueK0_LBL = new javax.swing.JLabel();
        m_ValueK0 = new javax.swing.JTextField();
        m_AValue_SLD = new javax.swing.JSlider();
        m_BValue_SLD = new javax.swing.JSlider();
        m_CValue_SLD = new javax.swing.JSlider();
        m_DValue_SLD = new javax.swing.JSlider();
        m_Start_BTN = new javax.swing.JButton();
        m_Reset_BTN = new javax.swing.JButton();
        Speed = new javax.swing.JSlider();
        jLabel8 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        m_Scale_BTN = new javax.swing.JCheckBox();
        m_Redraw_BTN = new javax.swing.JCheckBox();
        jPanel1 = new javax.swing.JPanel();
        m_Author_name = new javax.swing.JLabel();

        getContentPane().setLayout(null);

        m_ControlPannel.setLayout(null);

        m_ControlPannel.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0)));
        m_ControlPannel.setToolTipText("Controls");
        m_ValueA_LBL.setFont(new java.awt.Font("Arial", 1, 11));
        m_ValueA_LBL.setText("a :");
        m_ControlPannel.add(m_ValueA_LBL);
        m_ValueA_LBL.setBounds(10, 80, 20, 20);

        m_ValueA.setFont(new java.awt.Font("Arial", 0, 11));
        m_ValueA.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        m_ValueA.setText("0.6");
        m_ValueA.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                m_ValueAKeyPressed(evt);
            }
        });

        m_ControlPannel.add(m_ValueA);
        m_ValueA.setBounds(70, 100, 30, 20);

        m_ValueB_LBL.setFont(new java.awt.Font("Arial", 1, 11));
        m_ValueB_LBL.setText("b :");
        m_ControlPannel.add(m_ValueB_LBL);
        m_ValueB_LBL.setBounds(10, 120, 20, 20);

        m_ValueB.setFont(new java.awt.Font("Arial", 0, 11));
        m_ValueB.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        m_ValueB.setText("0.3");
        m_ValueB.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                m_ValueBKeyPressed(evt);
            }
        });

        m_ControlPannel.add(m_ValueB);
        m_ValueB.setBounds(70, 140, 30, 20);

        m_ValueC_LBL.setFont(new java.awt.Font("Arial", 1, 11));
        m_ValueC_LBL.setText("c :");
        m_ControlPannel.add(m_ValueC_LBL);
        m_ValueC_LBL.setBounds(10, 160, 20, 20);

        m_ValueC.setFont(new java.awt.Font("Arial", 0, 11));
        m_ValueC.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        m_ValueC.setText("0.06");
        m_ValueC.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                m_ValueCKeyPressed(evt);
            }
        });

        m_ControlPannel.add(m_ValueC);
        m_ValueC.setBounds(70, 180, 30, 20);

        m_ValueD_LBL.setFont(new java.awt.Font("Arial", 1, 11));
        m_ValueD_LBL.setText("d :");
        m_ControlPannel.add(m_ValueD_LBL);
        m_ValueD_LBL.setBounds(10, 200, 20, 20);

        m_ValueD.setFont(new java.awt.Font("Arial", 0, 11));
        m_ValueD.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        m_ValueD.setText("0.3");
        m_ValueD.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                m_ValueDKeyPressed(evt);
            }
        });

        m_ControlPannel.add(m_ValueD);
        m_ValueD.setBounds(70, 220, 30, 20);

        m_ValueP0_LBL.setFont(new java.awt.Font("Arial", 1, 11));
        m_ValueP0_LBL.setText("D0:");
        m_ControlPannel.add(m_ValueP0_LBL);
        m_ValueP0_LBL.setBounds(10, 10, 20, 20);

        m_ValueP0.setText("5");
        m_ValueP0.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                m_ValueP0KeyPressed(evt);
            }
        });

        m_ControlPannel.add(m_ValueP0);
        m_ValueP0.setBounds(40, 10, 50, 21);

        m_ValueK0_LBL.setFont(new java.awt.Font("Arial", 1, 11));
        m_ValueK0_LBL.setText("K0:");
        m_ControlPannel.add(m_ValueK0_LBL);
        m_ValueK0_LBL.setBounds(10, 40, 20, 20);

        m_ValueK0.setText("15");
        m_ValueK0.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                m_ValueK0KeyPressed(evt);
            }
        });

        m_ControlPannel.add(m_ValueK0);
        m_ValueK0.setBounds(40, 40, 50, 21);

        m_AValue_SLD.setFont(new java.awt.Font("MS Sans Serif", 0, 8));
        m_AValue_SLD.setMinorTickSpacing(1);
        m_AValue_SLD.setMajorTickSpacing(1);
        m_AValue_SLD.setValue(60);
        m_AValue_SLD.setSnapToTicks(true);
        m_AValue_SLD.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                m_AValue_SLDMouseDragged(evt);
            }
        });
        m_AValue_SLD.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                m_AValue_SLDMouseClicked(evt);
            }
        });

        m_ControlPannel.add(m_AValue_SLD);
        m_AValue_SLD.setBounds(30, 80, 80, 20);

        m_BValue_SLD.setFont(new java.awt.Font("MS Sans Serif", 0, 8));
        m_BValue_SLD.setMinorTickSpacing(1);
        m_BValue_SLD.setMajorTickSpacing(1);
        m_BValue_SLD.setValue(30);
        m_BValue_SLD.setSnapToTicks(true);
        m_BValue_SLD.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                m_BValue_SLDMouseDragged(evt);
            }
        });
        m_BValue_SLD.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                m_BValue_SLDMouseClicked(evt);
            }
        });

        m_ControlPannel.add(m_BValue_SLD);
        m_BValue_SLD.setBounds(30, 120, 80, 20);

        m_CValue_SLD.setFont(new java.awt.Font("MS Sans Serif", 0, 8));
        m_CValue_SLD.setMinorTickSpacing(1);
        m_CValue_SLD.setMajorTickSpacing(1);
        m_CValue_SLD.setValue(6);
        m_CValue_SLD.setSnapToTicks(true);
        m_CValue_SLD.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                m_CValue_SLDMouseDragged(evt);
            }
        });
        m_CValue_SLD.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                m_CValue_SLDMouseClicked(evt);
            }
        });

        m_ControlPannel.add(m_CValue_SLD);
        m_CValue_SLD.setBounds(30, 160, 80, 20);

        m_DValue_SLD.setFont(new java.awt.Font("MS Sans Serif", 0, 8));
        m_DValue_SLD.setMinorTickSpacing(1);
        m_DValue_SLD.setMajorTickSpacing(1);
        m_DValue_SLD.setValue(30);
        m_DValue_SLD.setSnapToTicks(true);
        m_DValue_SLD.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                m_DValue_SLDMouseDragged(evt);
            }
        });
        m_DValue_SLD.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                m_DValue_SLDMouseClicked(evt);
            }
        });

        m_ControlPannel.add(m_DValue_SLD);
        m_DValue_SLD.setBounds(30, 200, 80, 20);

        getContentPane().add(m_ControlPannel);
        m_ControlPannel.setBounds(10, 10, 120, 250);

        m_Start_BTN.setText("Start");
        m_Start_BTN.setFocusPainted(false);
        m_Start_BTN.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                m_Start_BTNMouseClicked(evt);
            }
        });

        getContentPane().add(m_Start_BTN);
        m_Start_BTN.setBounds(10, 270, 100, 25);

        m_Reset_BTN.setText("Reset");
        m_Reset_BTN.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                m_Reset_BTNMouseClicked(evt);
            }
        });

        getContentPane().add(m_Reset_BTN);
        m_Reset_BTN.setBounds(10, 300, 100, 25);

        Speed.setValue(0);
        Speed.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseDragged(java.awt.event.MouseEvent evt) {
                SpeedMouseDragged(evt);
            }
        });

        getContentPane().add(Speed);
        Speed.setBounds(10, 350, 100, 24);

        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel8.setText("Speed");
        getContentPane().add(jLabel8);
        jLabel8.setBounds(10, 330, 100, 15);

        jLabel10.setFont(new java.awt.Font("MS Sans Serif", 0, 9));
        jLabel10.setText("Slowly");
        getContentPane().add(jLabel10);
        jLabel10.setBounds(10, 380, 30, 10);

        jLabel11.setFont(new java.awt.Font("MS Sans Serif", 0, 9));
        jLabel11.setText("Faster");
        getContentPane().add(jLabel11);
        jLabel11.setBounds(80, 380, 30, 10);

        m_Scale_BTN.setText("Scale time graph");
        m_Scale_BTN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_Scale_BTNActionPerformed(evt);
            }
        });

        getContentPane().add(m_Scale_BTN);
        m_Scale_BTN.setBounds(10, 400, 150, 23);

        m_Redraw_BTN.setText(" Redraw graph");
        getContentPane().add(m_Redraw_BTN);
        m_Redraw_BTN.setBounds(10, 430, 150, 23);

        jPanel1.setLayout(null);

        jPanel1.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        m_Author_name.setFont(new java.awt.Font("MS Sans Serif", 0, 10));
        m_Author_name.setText("Martin \u0160ramko, sramko@intrak.sk");
        jPanel1.add(m_Author_name);
        m_Author_name.setBounds(20, 0, 152, 20);

        getContentPane().add(jPanel1);
        jPanel1.setBounds(10, 480, 190, 20);

    }//GEN-END:initComponents

    private void m_DValue_SLDMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_m_DValue_SLDMouseClicked
        double v = (double)m_DValue_SLD.getValue() / 100D;
         m_ValueD.setText(decFormat.format(v));
         SetEQPoint();
         Recount();
    }//GEN-LAST:event_m_DValue_SLDMouseClicked

    private void m_CValue_SLDMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_m_CValue_SLDMouseClicked
        double v = (double)m_CValue_SLD.getValue() / 100D;
         m_ValueC.setText(decFormat.format(v));
         SetEQPoint();
         Recount();
    }//GEN-LAST:event_m_CValue_SLDMouseClicked

    private void m_BValue_SLDMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_m_BValue_SLDMouseClicked
         double v = (double)m_BValue_SLD.getValue() / 100D;
         m_ValueB.setText(decFormat.format(v));
         SetEQPoint();
         Recount();
    }//GEN-LAST:event_m_BValue_SLDMouseClicked

    private void m_AValue_SLDMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_m_AValue_SLDMouseClicked
        double v = (double)m_AValue_SLD.getValue() / 100D;
        m_ValueA.setText(decFormat.format(v));
        SetEQPoint();
        Recount();
    }//GEN-LAST:event_m_AValue_SLDMouseClicked

    private void m_DValue_SLDMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_m_DValue_SLDMouseDragged
         double v = (double)m_DValue_SLD.getValue() / 100D;
         m_ValueD.setText(decFormat.format(v));
         SetEQPoint();
         Recount();
    }//GEN-LAST:event_m_DValue_SLDMouseDragged

    private void m_CValue_SLDMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_m_CValue_SLDMouseDragged
         double v = (double)m_CValue_SLD.getValue() / 100D;
         m_ValueC.setText(decFormat.format(v));
         SetEQPoint();
         Recount();
    }//GEN-LAST:event_m_CValue_SLDMouseDragged

    private void m_BValue_SLDMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_m_BValue_SLDMouseDragged
         double v = (double)m_BValue_SLD.getValue() / 100D;
         m_ValueB.setText(decFormat.format(v));
         SetEQPoint();
         Recount();
    }//GEN-LAST:event_m_BValue_SLDMouseDragged

    private void m_AValue_SLDMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_m_AValue_SLDMouseDragged
        double v = (double)m_AValue_SLD.getValue() / 100D;
        m_ValueA.setText(decFormat.format(v));
        SetEQPoint();
        Recount();
    }//GEN-LAST:event_m_AValue_SLDMouseDragged

    private void m_Reset_BTNMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_m_Reset_BTNMouseClicked
        PHPoint.Set(15.0,5.0);
        m_ValueA.setText(String.valueOf("0.6"));
        m_AValue_SLD.setValue(60);
        m_ValueB.setText(String.valueOf("0.3"));
        m_BValue_SLD.setValue(30);
        m_ValueC.setText(String.valueOf("0.06"));
        m_CValue_SLD.setValue(6);
        m_ValueD.setText(String.valueOf("0.3"));
        m_DValue_SLD.setValue(30);
        m_ValueK0.setText(String.valueOf(PHPoint.m_doubleValueX.Get()));
        m_ValueP0.setText(String.valueOf(PHPoint.m_doubleValueY.Get()));
        m_Graph.stop();
        m_KPGraph.stop();
        initVectorGraph();
        initKPGraph();
        m_Graph.start();
        m_KPGraph.start();
        Speed.setValue(0);
        m_Scale_BTN.setSelected(false);
        m_Redraw_BTN.setSelected(false);
        m_Start_BTN.setText("Start");
    }//GEN-LAST:event_m_Reset_BTNMouseClicked

    private void m_Start_BTNMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_m_Start_BTNMouseClicked
       if(m_Start_BTN.getText() == "Start"){
            if( m_Graph.IsPaused() && m_KPGraph.IsPaused()) {
                m_Graph.UnPause(); 
                m_KPGraph.UnPause();  
            }else{
                 Recount();
            }
            System.out.println("Start");
            m_Start_BTN.setText("Pause");
       }else{
        m_Graph.Pause();
        m_KPGraph.Pause();  
        m_Start_BTN.setText("Start");
       }
        
    }//GEN-LAST:event_m_Start_BTNMouseClicked

    private void m_Scale_BTNActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_m_Scale_BTNActionPerformed
        m_KPGraph.Scalable = m_Scale_BTN.isSelected();
    }//GEN-LAST:event_m_Scale_BTNActionPerformed

    private void SpeedMouseDragged(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_SpeedMouseDragged
        m_Graph.speed=Speed.getValue();
        m_KPGraph.speed=Speed.getValue();
    }//GEN-LAST:event_SpeedMouseDragged

    private void m_ValueDKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_m_ValueDKeyPressed
       try{
             if (evt.getKeyCode() == evt.VK_ENTER) {
                if( Double.valueOf(m_ValueD.getText()).doubleValue() > 1.0D ) {
                   JOptionPane.showMessageDialog(null, "Out of Range (0.0 - 1.0)");
                    m_ValueD.setText(String.valueOf("1.0"));
                    d=1.0;
                }
                 SetEQPoint();
                 Recount();
                
              }
        }catch(NumberFormatException e){
            if (evt.getKeyCode() == evt.VK_ENTER){
                m_ValueD.setText(String.valueOf("0.0"));
               d=0.0;
            }
         }
       m_DValue_SLD.setValue((int)(d*100));
    }//GEN-LAST:event_m_ValueDKeyPressed

    private void m_ValueCKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_m_ValueCKeyPressed
         try{
             if (evt.getKeyCode() == evt.VK_ENTER) {
                 if( Double.valueOf(m_ValueC.getText()).doubleValue() > 1.0D ) {
                   JOptionPane.showMessageDialog(null, "Out of Range (0.0 - 1.0)");
                    m_ValueC.setText(String.valueOf("1.0"));
                    c=1.0;
                }
                 SetEQPoint();
                 Recount();
                
              }
        }catch(NumberFormatException e){
            if (evt.getKeyCode() == evt.VK_ENTER){
                m_ValueC.setText(String.valueOf("0.0"));
               c=0.0;
            }
         }
         m_CValue_SLD.setValue((int)(c*100));
    }//GEN-LAST:event_m_ValueCKeyPressed

    private void m_ValueBKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_m_ValueBKeyPressed
         try{
             if (evt.getKeyCode() == evt.VK_ENTER) {
                if( Double.valueOf(m_ValueB.getText()).doubleValue() > 1.0D ) {
                   JOptionPane.showMessageDialog(null, "Out of Range (0.0 - 1.0)");
                    m_ValueB.setText(String.valueOf("1.0"));
                    b=1.0;
                }
                 SetEQPoint();
                 Recount();
               
              }
        }catch(NumberFormatException e){
            if (evt.getKeyCode() == evt.VK_ENTER){
                m_ValueB.setText(String.valueOf("0.0"));
               b=0.0;
            }
         }
         m_BValue_SLD.setValue((int)(b*100));
    }//GEN-LAST:event_m_ValueBKeyPressed

    private void m_ValueAKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_m_ValueAKeyPressed
        try{
             if (evt.getKeyCode() == evt.VK_ENTER) {
                if( Double.valueOf(m_ValueA.getText()).doubleValue() > 1.0D ) {
                   JOptionPane.showMessageDialog(null, "Out of Range (0.0 - 1.0)");
                    m_ValueA.setText(String.valueOf("1.0"));
                    a=1.0;
                }
                 SetEQPoint();
                 Recount();    
              }
        }catch(NumberFormatException e){
            if (evt.getKeyCode() == evt.VK_ENTER){
                m_ValueA.setText(String.valueOf("0.0"));
               a=0.0;
            }
         }
        m_AValue_SLD.setValue((int)(a*100));
    }//GEN-LAST:event_m_ValueAKeyPressed
    
    private void m_ValueP0KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_m_ValueP0KeyPressed
         try{
             if (evt.getKeyCode() == evt.VK_ENTER) {
                if( Double.valueOf(m_ValueP0.getText()).doubleValue() > 100.0D ) {
                   JOptionPane.showMessageDialog(null, "Out of Range (0.0 - 100.0)");
                    m_ValueP0.setText(String.valueOf("100.0"));
                    PHPoint.m_doubleValueX.Set(100.0);
                }
                if(m_Redraw_BTN.isSelected()) {
                    m_Graph.AddStartCondition(PHPoint);
                }
                else{
                    m_Graph.DisableMultiGraphs();
                }  
                SetPHPoint(Double.valueOf(m_ValueK0.getText()).doubleValue(),Double.valueOf(m_ValueP0.getText()).doubleValue());
                System.out.println("PHPoint : "+PHPoint.m_doubleValueX.Get()+","+PHPoint.m_doubleValueY.Get());
                Recount();
             }
        }catch(NumberFormatException e){
            if (evt.getKeyCode() == evt.VK_ENTER) {
                m_ValueP0.setText(String.valueOf("0.0"));
                PHPoint.m_doubleValueY.Set(0.0);
                
            }
        }
    }//GEN-LAST:event_m_ValueP0KeyPressed

    private void m_ValueK0KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_m_ValueK0KeyPressed
        try{
           if (evt.getKeyCode() == evt.VK_ENTER) {
                if( Double.valueOf(m_ValueK0.getText()).doubleValue() > 100.0D ) {
                   JOptionPane.showMessageDialog(null, "Out of Range (0.0 - 100.0)");
                    m_ValueK0.setText(String.valueOf("100.0"));
                    PHPoint.m_doubleValueY.Set(100.0);
                }
                if(m_Redraw_BTN.isSelected()) {
                    m_Graph.AddStartCondition(PHPoint);
                }
                else{
                    m_Graph.DisableMultiGraphs();
                }  
                SetPHPoint(Double.valueOf(m_ValueK0.getText()).doubleValue(),Double.valueOf(m_ValueP0.getText()).doubleValue());
                System.out.println("PHPoint : "+PHPoint.m_doubleValueX.Get()+","+PHPoint.m_doubleValueY.Get());
                Recount();
           }
        }catch(NumberFormatException e){
            if (evt.getKeyCode() == evt.VK_ENTER) {
                m_ValueK0.setText(String.valueOf("0.0"));
                PHPoint.m_doubleValueX.Set(0.0);
            }
        }
    }//GEN-LAST:event_m_ValueK0KeyPressed
    private void m_GraphMouseClicked(java.awt.event.MouseEvent e) {
       if( m_Graph.IsPaused() && m_KPGraph.IsPaused()) {
            m_Graph.UnPause(); 
            m_KPGraph.UnPause();  
       }
       if(m_Redraw_BTN.isSelected()){
           m_Graph.AddStartCondition(PHPoint);
       }else {
         m_Graph.DisableMultiGraphs();
       }
        double x=m_Graph.GetTX(e.getX());
        double y=m_Graph.GetTY(e.getY());

        if( x > 100.0D ) {
               JOptionPane.showMessageDialog(null, "Out of Range (0.0 - 100.0)");

                x=100.0;
        }
         if( y > 100.0D ) {
               JOptionPane.showMessageDialog(null, "Out of Range (0.0 - 100.0)");

               y=100.0;
        }
        SetPHPoint(m_Graph.GetRX(x),m_Graph.GetRY(y)); 
        m_ValueK0.setText(decFormat.format(PHPoint.m_doubleValueX.Get()));
        m_ValueP0.setText(decFormat.format(PHPoint.m_doubleValueY.Get()));
        System.out.println("PHPoint : "+PHPoint.m_doubleValueX.Get()+","+PHPoint.m_doubleValueY.Get());
        Recount();
        m_Start_BTN.setText("Pause");
      
   }
    private void SetEQPoint() {
        GetSetParams();
        try{
            //m_Graph.SetEQPoint( (d / (b)), ( a / c) ); 
           m_Graph.SetEQPoint( (d / (b*c)), ( a / c) ); 
            
        }catch(ArithmeticException e){
            System.out.println("ArithmeticException :"+e.getMessage());
        }
    }
    public void SetPHPoint(double x,double y) {
       double xK,xP;
       xK=m_Graph.GetTX(x);
       xP=m_Graph.GetTY(y);
       if (xK >= 0 && xP >= 0) PHPoint.Set(xK,xP);
   }
    private void GetSetParams() {
        a = Double.valueOf(m_ValueA.getText()).doubleValue();
        b = Double.valueOf(m_ValueB.getText()).doubleValue();
        c = Double.valueOf(m_ValueC.getText()).doubleValue();
        d = Double.valueOf(m_ValueD.getText()).doubleValue();   
    }
    javax.swing.JLabel jLabel1;
    javax.swing.JLabel jLabel2;
    javax.swing.JLabel jLabel3;
    javax.swing.JLabel jLabel4;
    javax.swing.JLabel jLabel5;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    javax.swing.JSlider Speed;
    javax.swing.JLabel jLabel10;
    javax.swing.JLabel jLabel11;
    javax.swing.JLabel jLabel8;
    javax.swing.JPanel jPanel1;
    javax.swing.JSlider m_AValue_SLD;
    javax.swing.JLabel m_Author_name;
    javax.swing.JSlider m_BValue_SLD;
    javax.swing.JSlider m_CValue_SLD;
    javax.swing.JPanel m_ControlPannel;
    javax.swing.JSlider m_DValue_SLD;
    javax.swing.JCheckBox m_Redraw_BTN;
    javax.swing.JButton m_Reset_BTN;
    javax.swing.JCheckBox m_Scale_BTN;
    javax.swing.JButton m_Start_BTN;
    javax.swing.JTextField m_ValueA;
    javax.swing.JLabel m_ValueA_LBL;
    javax.swing.JTextField m_ValueB;
    javax.swing.JLabel m_ValueB_LBL;
    javax.swing.JTextField m_ValueC;
    javax.swing.JLabel m_ValueC_LBL;
    javax.swing.JTextField m_ValueD;
    javax.swing.JLabel m_ValueD_LBL;
    javax.swing.JTextField m_ValueK0;
    javax.swing.JLabel m_ValueK0_LBL;
    javax.swing.JTextField m_ValueP0;
    javax.swing.JLabel m_ValueP0_LBL;
    // End of variables declaration//GEN-END:variables
    
}
