/*
 * JCoordinates.java
 *
 * Created on Utorok, 2005, janur 18, 1:27
 */
import java.awt.*;

/**
 *Stara sa o transformacne veci do m_JGraph
 * @author  X-so
 */
public class m_JCoordinates {
    public m_JPoint m_Middle;
    private m_JInt m_Width,m_Height;
    private m_JDouble m_Xmin,m_Ymin,m_Xmax,m_Ymax;
    private double xdiff,ydiff; 
    /** Creates a new instance of JCoordinates */
    public m_JCoordinates() {
        m_Middle = new m_JPoint();
        m_Width = new m_JInt();
        m_Height = new m_JInt();
        m_Xmin = new m_JDouble();
        m_Ymin = new m_JDouble();
        m_Xmax = new m_JDouble();
        m_Ymax = new m_JDouble();

    }
    /**
     *window_width - sirka okna v px
     *<br>
     *window_height - vyska okna v px
     *<br>
     *x_ax         - poloha x_osi v okne v px
     *<br>
     *y_ax         - poloha y_osi v okne v px
     *<br>
     *x_min        - minimalna x hodnota kt, sa ma vykreslit (tato je vo funkcnych hodnotach)
     *<br>
     *y_min        - minimalna y hodnota kt, sa ma vykreslit (tato je vo funkcnych hodnotach)
     *<br>
     *x_max        - maximalna x hodnota kt, sa ma vykreslit (tato je vo funkcnych hodnotach)
     *<br>
     *y_max        - maximalna y hodnota kt, sa ma vykreslit (tato je vo funkcnych hodnotach)
    */
    public m_JCoordinates(  int window_width,
                            int window_height, 
                            int x_ax, 
                            int y_ax,
                            double x_min,
                            double x_max,
                            double y_min,
                            double y_max)
    {
       m_Middle = new m_JPoint(x_ax, y_ax); //udava polohou osi v px
       m_Width = new m_JInt(window_width - x_ax); 
       m_Height = new m_JInt(window_height - 2*y_ax);
       m_Xmin = new m_JDouble(x_min);
       m_Ymin = new m_JDouble(y_min);
       m_Xmax = new m_JDouble(x_max);
       m_Ymax = new m_JDouble(y_max);
       xdiff = x_max - x_min;
       ydiff = y_max - y_min;
    }

    /**
     *Vrat realne suradnice v px, ktore sa daju vykreslit priamo do okna
     */
      /**vstupm je funkcna hodnota vystup je hodnota v px, ktoru mozno vykreslit*/
    public double GetRX(double x){
        return m_Middle.m_intValueX.Get() + (int)Math.floor(((double)m_Width.Get()* ( x)) / xdiff); 
        //       return  + (int)Math.floor(((double)m_Width.Get() * (-m_Xmin.Get() + x)) / (xdiff * Math.exp(zoom))); 
    }
    
    public double GetRY(double y){
        return  m_Middle.m_intValueY.Get() + (int)Math.floor(((double)m_Height.Get() * (m_Ymax.Get() - y)) / ydiff); 
        //return m_Middle.m_intValueY.Get()+ (int)Math.floor(((double)m_Height.Get() * (m_Ymax.Get() - y)) / (ydiff * Math.exp(zoom))); 
    }
     /**
     *Vrat suradnice ktore su pretransformovane do naseho suradneho systemu
     */
    public double GetTX(double x) {
        return  m_Xmin.Get() + (double)(xdiff * (double)(x - m_Middle.m_intValueX.Get()) ) / (double)m_Width.Get() ; 
    }
    public double GetTY(double y) {
        return  m_Ymax.Get() - (double)(ydiff * (double)(y - m_Middle.m_intValueY.Get()) ) / (double)m_Height.Get() ;
    }
  
    
    public void SetDimension(int Width, int Height) {
        m_Width.Set(Width);
        m_Height.Set(Height);
    }
    
    public m_JPoint GetDimension(int Width, int Height) {
        return new m_JPoint(m_Width.Get(), m_Height.Get());
    }
    public m_JPoint GetRange() {
     return new m_JPoint(m_Xmax.Get() - m_Xmin.Get(), m_Ymax.Get() - m_Ymin.Get());
    
    }
    /** nastavime nove max - min funkcionalne hodnoty */
    public void SetRange(double x_min, double x_max, double y_min, double y_max ) {
        m_Xmin.Set(x_min);
        m_Xmax.Set(x_max);
        m_Ymin.Set(y_min);
        m_Ymax.Set(y_max);
        xdiff = x_max - x_min;
        ydiff = y_max - y_min;
    }
    
    public int GetWidth() {
        return m_Width.Get();
    }
    public int GetHeight() {
        return m_Height.Get();
    }
  
    public double GetMaxX() {
        return m_Xmax.Get();
    }
    public double GetMaxY() {
        return m_Ymax.Get();
    }
    
    public double GetMinY() {
        return m_Ymin.Get();
    }
   
    public double GetMinX() {
        return m_Xmin.Get();
    }
}
