/*
 * m_JGraph.java
 *
 * Created on tvrtok, 2005, janur 20, 23:39
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.*;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;  
/**
 *
 * @author  X-so
 */
abstract public class m_JGraph extends JPanel implements Runnable {
    public m_JCoordinates coord;
    public Thread graphThread;
    private Image offScreenImage;
    private m_JPoint MousePoint;
    public boolean ValuesDefined;
    public boolean needToRepaint;
    public int Counter;
    public double x[]; //x hodnoty pre graf
    public double y1[]; // hodnoty funkcie f1(x) = y1
    public double y2[]; // hodnoty funkcie f2(x) = y2
    public double m[][]; //
    DecimalFormat decFormat;  
    private boolean ClearOnly;
    public int speed; 
    private boolean paused;
    /** Creates a new instance of m_JGraph */
    public m_JGraph() {
       super();
       graphThread = null;
       ValuesDefined = false;
       MousePoint = null;
       x=null;
       y1=null;
       y2=null;
       needToRepaint = true;

    }
    /** Inicializacia triedy JGraph <br>
     *window_width - sirka okna v px
     *<br>
     *window_height - vyska okna v px
     *<br>
     *x_ax         - poloha x_osi v okne v px
     *<br>
     *y_ax         - poloha y_osi v okne v px
     *<br>
     *x_min        - minimalna x hodnota kt, sa ma vykreslit (tato je vo funkcnych hodnotach)
     *<br>
     *y_min        - minimalna y hodnota kt, sa ma vykreslit (tato je vo funkcnych hodnotach)
     *<br>
     *x_max        - maximalna x hodnota kt, sa ma vykreslit (tato je vo funkcnych hodnotach)
     *<br>
     *y_max        - maximalna y hodnota kt, sa ma vykreslit (tato je vo funkcnych hodnotach)
    */
    public void init(int window_width,
                            int window_height, 
                            int x_ax, 
                            int y_ax,
                            double x_min,
                            double x_max,
                            double y_min,
                            double y_max) {
       MousePoint = new m_JPoint(x_ax, y_ax);
       coord = new m_JCoordinates(window_width, window_height, x_ax, y_ax, x_min, x_max, y_min, y_max);
       //definuj polia na vykreslovanie
       x = new double[coord.GetWidth()*10];
       y1 = new double[coord.GetHeight()*10];
       y2 = new double[coord.GetHeight()*10];     
       //vytvor buffer pre shadow screen
       offScreenImage = createImage(getSize().width,getSize().height);
       Counter=1;
       DecimalFormatSymbols decimalformatsymbols = new DecimalFormatSymbols();
       decimalformatsymbols.setDecimalSeparator('.');
       decFormat = new DecimalFormat("#0.00", decimalformatsymbols);  
       ClearOnly=false;
       speed = 0;
       paused = false;
    }
     public void run() {
        Thread myThread = Thread.currentThread(); 
        while( graphThread == myThread ) {
            if(needToRepaint) this.repaint();
                try{
                    graphThread.sleep(105-speed);
                    needToRepaint=true;
                }catch(InterruptedException e) {
                }   
        }
    }    
   public void start() {
     if ( graphThread == null) {
        graphThread = new Thread(this,"Graph");
        graphThread.start();
        
    }
  }
   
   public void stop() {
    Counter=1;
    graphThread = null;
   }
   /** Abstraktna trieda ktoru treba definovat vlastne nastavenie */
   abstract Graphics Draw(Graphics offScreenGraphics);
   
   public void paint(Graphics g) {
       
       Graphics offScreenGraphics = offScreenImage.getGraphics();	
       //clear bg
       offScreenGraphics.setColor(Color.lightGray);
       offScreenGraphics.fillRect(0,0,getSize().width-1, getSize().height-1);
       //draw border around
       offScreenGraphics.setColor(Color.black);
       offScreenGraphics.drawRect(0,0,getSize().width-1, getSize().height-1);
       
       //vykresli osi
       DrawAxes(offScreenGraphics); 
 
       //vykresli poziciu mysky
       if(MousePoint.m_Defined){
           offScreenGraphics.setColor(Color.black);
          
           String xa=decFormat.format(MousePoint.m_doubleValueX.Get());
           String ya=decFormat.format(MousePoint.m_doubleValueY.Get());
           offScreenGraphics.drawString("["+xa+","+ya+"]",coord.GetWidth()-100,10);
           
       }
       //vykresli vlastne veci
       if (!ClearOnly) 
           Draw(offScreenGraphics);
       else
           ClearOnly=false;
       
       //vykresli do komponenetu
       
       g.drawImage(offScreenImage,0,0,this);
       super.paint(offScreenGraphics);       
       needToRepaint=false;    
   }
   private void DrawAxes(Graphics g) {
       //vykresli osi na grafe 
       g.setColor(Color.black);
       int z_x=(int)coord.GetRX(0);
       int z_y=(int)coord.GetRY(0);
       g.drawLine(0,(int)coord.GetRY(0),getSize().width,(int)coord.GetRY(0));
       g.drawLine((int)coord.GetRX(0),0,(int)coord.GetRX(0),getSize().height);
       
       //drawTicks 
      
       int x_spacing = (int)coord.GetRX(0D) +10;
       int y_spacing = (int)coord.GetRY(coord.GetMaxY())+10;
       for(int y = 0; y <getSize().height; y+=y_spacing){
                g.setColor(Color.blue);
                g.drawLine((int)z_x-2,y,(int)z_x+2,y);
                g.setColor(Color.black);
                g.setFont(new java.awt.Font("MS Sans Serif", 0, 9));
                g.drawString(String.valueOf((int)coord.GetTY(y)), (int)z_x- (String.valueOf((int)coord.GetTY(y))).length()*5-2 , y+2);
       }
       for (int x = 0 ; x < getSize().width; x +=x_spacing) { 
              
                g.setColor(Color.blue);
                g.drawLine(x,(int)z_y-2,x,(int)z_y+2);
                g.setColor(Color.black);
                g.setFont(new java.awt.Font("MS Sans Serif", 0, 9));
                g.drawString(String.valueOf((int)coord.GetTX(x)),x - (String.valueOf((int)coord.GetTX(x))).length()*2,(int)z_y+12);
       }
       
   }

   /**
    *m[] - dvojrozmerne pole obsahujuce minimalne  a maximalne hodnoty na osiach x, y1, y2<br>
    *m[0][] - mimalne  0  - x , 1 - y1, 2 - y2 <br>
    *                   
    *m[1][] - maximalne 0  - x , 1 - y1, 2 - y2 <br>
    *
    *xV[]  - hodnoty, kt maju byt vynesene na x os<br>
    *y1V[] - hodnoty, prvej krivky, ktore budu vynesene na y os<br>
    *y2V[] -  hodnoty, druhej krivky, ktore budu vynesene na y os
    */
   public abstract void SetInputValues(double mi[][], double xV[],double y1V[],double y2V[]);
  
   public final void MouseMoved(MouseEvent evt) {
//        if (evt.getX() > coord.m_Middle.m_intValueX.Get() && evt.getY() < (coord.GetHeight() - coord.m_Middle.m_intValueY.Get()) ) {
            MousePoint.Set(coord.GetTX(evt.getX()),coord.GetTY(evt.getY()));
            needToRepaint = true;
//        }
   }
   public final void MouseExited(MouseEvent evt) {
        MousePoint.m_Defined=false;
        needToRepaint = true;
   }
   /**hodnota ktora sa moze rovno vykreslit*/
   public double GetRX(double v) {
       return coord.GetRX(v);
   }
   /** pretransformovana hodnota podla x_max,y_max */
   public double GetTX(double v) {
       return coord.GetTX(v);
   }
   /**hodnota ktora sa moze rovno vykreslit*/
   public double GetRY(double v) {
       return coord.GetRY(v);
   }
   /** pretransformovana hodnota podla x_max,y_max */
   public double GetTY(double v) {
       return coord.GetTY(v);
   }
   /** realna sirka okna kde sa vykresluje */
   public int GetWidth() {
        return coord.GetWidth();
   }
   /** realna vyska okna kde sa vykresluje */
   public int GetHeight() {
        return coord.GetHeight();
   }
   
   public void Clear() {
        ClearOnly=true;
        ValuesDefined=false;
   }
   public void Pause(){
        paused = true;
   }
   public void UnPause(){
        paused = false;
   }
   public boolean IsPaused() {
        return paused;
   }
   public m_JPoint GetAxMiddle() {
        return coord.m_Middle;
   }
}
